//+------------------------------------------------------------------+
//|                                         2CCI_ZeroCross_Alert.mq4 |
//|                   Copyright  2005, Jason Robinson (jnrtrading). |
//|                                      http://www.jnrtrading.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Harper"
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window

//---- indicator parameters
extern int SIGMA_Period=20;
extern int SIGMA_Shift=0;
extern bool Sigma3_Alert = true;
extern bool Sigma2_Alert = true;
extern bool Sigma1_Alert = false;
//---- buffers
double UpperBand3;
double UpperBand2;
double UpperBand1;
double MidPoint;
double LowerBand1;
double LowerBand2;
double LowerBand3;
int UpperBand3S=0;
int UpperBand2S=0;
int UpperBand1S=0;
int LowerBand3S=0;
int LowerBand2S=0;
int LowerBand1S=0;
double Mid=0;
double Atr=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

           Mid = iMA(NULL,0,SIGMA_Period,0,MODE_SMA,PRICE_CLOSE,0);
           Atr = iATR(NULL,0,SIGMA_Period,0);
            
           UpperBand3 = Mid + (4.854 * Atr);
           UpperBand2 = Mid + (3.236 * Atr);
           UpperBand1 = Mid + (1.618 * Atr);
           MidPoint = iMA(NULL,0,SIGMA_Period,0,MODE_EMA,PRICE_CLOSE,0);
           LowerBand1 = Mid - (1.618 * Atr);
           LowerBand2 = Mid - (3.236 * Atr);
           LowerBand3 = Mid - (4.854 * Atr); 

   
//---- 
   if ((Sigma3_Alert == true) && (UpperBand3S == 0))
   {
   if((UpperBand3 < High[0])){
         Alert(Symbol(), ", M", Period(), ": Sigma +3");
         UpperBand3S = 1;
         UpperBand2S = 1;         
         UpperBand1S = 1;
         LowerBand3S = 0;
         LowerBand2S = 0;
         LowerBand1S = 0;       
   }}
   if ((Sigma2_Alert == true) && (UpperBand2S == 0))
   {
   if((UpperBand2 < High[0]) && (UpperBand3 > High[0])){   
         Alert(Symbol(), ", M", Period(), ": Sigma +2");
         UpperBand3S = 0;
         UpperBand2S = 1;
         UpperBand1S = 1;
         LowerBand3S = 0;
         LowerBand2S = 0;
         LowerBand1S = 0;         
   }}
   if ((Sigma1_Alert == true) && (UpperBand1S == 0))
   {
   if((UpperBand1 < High[0]) && (UpperBand2 > High[0])&& (UpperBand1S == 0)) {   
         Alert(Symbol(), ", M", Period(), ": Sigma +1");
         UpperBand3S = 0;
         UpperBand2S = 0;                  
         UpperBand1S = 1;
         LowerBand3S = 0;
         LowerBand2S = 0;
         LowerBand1S = 0;         
   }}
   if(UpperBand1 > High[0]) {   
         UpperBand3S = 0;
         UpperBand2S = 0;                  
         UpperBand1S = 0;
   }
//   Comment("Cena prekrocila Crazy Zone: ", Open[0]);
   
   if ((Sigma3_Alert == true) && (LowerBand3S == 0))
   {
   if((LowerBand3 > Low[0])){
         Alert(Symbol(), ", M", Period(), ": Sigma -3");
         LowerBand3S = 1;
         LowerBand2S = 1;
         LowerBand1S = 1;
         UpperBand3S = 0;
         UpperBand2S = 0;                  
         UpperBand1S = 0;
   }}
   if ((Sigma2_Alert == true) && (LowerBand2S == 0))
   {
   if((LowerBand2 > Low[0]) && (LowerBand3 < Low[0])){
         Alert(Symbol(), ", M", Period(), ": Sigma -2");
         LowerBand3S = 0;
         LowerBand2S = 1;
         LowerBand1S = 1;         
         UpperBand3S = 0;
         UpperBand2S = 0;                  
         UpperBand1S = 0;
   }}   
   if ((Sigma1_Alert == true) && (LowerBand1S == 0))
   {
   if((LowerBand1 > Low[0]) && (LowerBand2 < Low[0])) {
         Alert(Symbol(), ", M", Period(), ": Sigma -1");
         LowerBand3S = 0;
         LowerBand2S = 0;
         LowerBand1S = 1;
         UpperBand3S = 0;
         UpperBand2S = 0;                  
         UpperBand1S = 0;
   }}   
   if(LowerBand1 < Low[0]) {
         LowerBand3S = 0;
         LowerBand2S = 0;
         LowerBand1S = 0;
   }   
//   Comment("Cena prekrocila Panic Zone: ", Open[0]);

   
//----
   return(0);
  }
//+------------------------------------------------------------------+