//+------------------------------------------------------------------+
//|                                                          TRM.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//+------------------------------------------------------------------+
//
#property copyright "Copyright  2006, Harper and Rambajs"
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color2 Magenta
#property indicator_color3 Gray
#property indicator_color4 Gray
#property indicator_color5 Magenta
#property indicator_color6 Gray
#property indicator_color7 Gray
#property indicator_color8 Magenta

//---- indicator parameters
extern int SIGMA_Period=20;
extern int SIGMA_Shift=0;
//---- indicator buffers
//---- buffers
double UpperBand3[];
double UpperBand2[];
double UpperBand1[];
double MidPoint[];
double LowerBand1[];
double LowerBand2[];
double LowerBand3[];
double Mid=0;
double Atr=0;
//----
int ExtCountedBars=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   int    draw_begin;
   string short_name;

//---- indicators
//---- drawing settings
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,MidPoint);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,UpperBand1);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,UpperBand2);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,UpperBand3);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,LowerBand1);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,LowerBand2);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,LowerBand3);

   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   draw_begin=SIGMA_Period-1;
//---- indicator short name
   short_name="SIGMA(";
   IndicatorShortName(short_name+SIGMA_Period+")");
   SetIndexDrawBegin(0,draw_begin);
  
//---- initialization done

//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   if(Bars<=SIGMA_Period) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
//----
      RefreshRates(); 
      sigma();      
   return(0);
  }
//+------------------------------------------------------------------+
//| SIGMA BANDS                                                      |
//+------------------------------------------------------------------+
void sigma()
  {
   double pr=2.0/(SIGMA_Period+1);
   int    pos=Bars-2;
   if(ExtCountedBars>2) pos=Bars-ExtCountedBars-1;
//---- main calculation loop
   while(pos>=0)
     {
           Mid = iMA(NULL,0,SIGMA_Period,0,MODE_SMA,PRICE_CLOSE,pos);
           Atr = iATR(NULL,0,SIGMA_Period,0);
            
           UpperBand3[pos]= Mid + (4.854 * Atr);
           UpperBand2[pos]= Mid + (3.236 * Atr);
           UpperBand1[pos]= Mid + (1.618 * Atr);
           MidPoint[pos]=iMA(NULL,0,SIGMA_Period,0,MODE_EMA,PRICE_CLOSE,pos);
           LowerBand1[pos]= Mid - (1.618 * Atr);
           LowerBand2[pos]= Mid - (3.236 * Atr);
           LowerBand3[pos]= Mid - (4.854 * Atr);  
 	   pos--;
     }
  }


